package com.hai.dao;

import com.hai.entity.HighOrder;
import com.hai.entity.HighOrderExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighOrderMapper extends HighOrderMapperExt {
    @SelectProvider(type=HighOrderSqlProvider.class, method="countByExample")
    long countByExample(HighOrderExample example);

    @DeleteProvider(type=HighOrderSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighOrderExample example);

    @Delete({
        "delete from high_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_order (order_no, mem_discount_id, ",
        "mem_discount_name, mem_id, ",
        "mem_name, mem_phone, ",
        "mem_card_id, mem_card_type, ",
        "mem_card_no, pay_model, ",
        "pay_type, pay_gold, ",
        "pay_price, pay_real_price, ",
        "pay_serial_no, deduction_price, ",
        "order_status, total_price, ",
        "create_time, pay_time, ",
        "cancel_time, cancel_remarks, ",
        "finish_time, remarks, ",
        "refund_time, refund_price, ",
        "refund_content, refusal_refund_content, ",
        "Identification_code, profit_sharing_status, ",
        "profit_sharing_ratio, account_merchant_num, ",
        "ext_1, ext_2, ext_3)",
        "values (#{orderNo,jdbcType=VARCHAR}, #{memDiscountId,jdbcType=BIGINT}, ",
        "#{memDiscountName,jdbcType=VARCHAR}, #{memId,jdbcType=BIGINT}, ",
        "#{memName,jdbcType=VARCHAR}, #{memPhone,jdbcType=VARCHAR}, ",
        "#{memCardId,jdbcType=BIGINT}, #{memCardType,jdbcType=INTEGER}, ",
        "#{memCardNo,jdbcType=VARCHAR}, #{payModel,jdbcType=INTEGER}, ",
        "#{payType,jdbcType=INTEGER}, #{payGold,jdbcType=INTEGER}, ",
        "#{payPrice,jdbcType=DECIMAL}, #{payRealPrice,jdbcType=DECIMAL}, ",
        "#{paySerialNo,jdbcType=VARCHAR}, #{deductionPrice,jdbcType=DECIMAL}, ",
        "#{orderStatus,jdbcType=INTEGER}, #{totalPrice,jdbcType=DECIMAL}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{payTime,jdbcType=TIMESTAMP}, ",
        "#{cancelTime,jdbcType=TIMESTAMP}, #{cancelRemarks,jdbcType=VARCHAR}, ",
        "#{finishTime,jdbcType=TIMESTAMP}, #{remarks,jdbcType=VARCHAR}, ",
        "#{refundTime,jdbcType=TIMESTAMP}, #{refundPrice,jdbcType=DECIMAL}, ",
        "#{refundContent,jdbcType=VARCHAR}, #{refusalRefundContent,jdbcType=VARCHAR}, ",
        "#{identificationCode,jdbcType=BIGINT}, #{profitSharingStatus,jdbcType=BIT}, ",
        "#{profitSharingRatio,jdbcType=DECIMAL}, #{accountMerchantNum,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighOrder record);

    @InsertProvider(type=HighOrderSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighOrder record);

    @SelectProvider(type=HighOrderSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mem_discount_id", property="memDiscountId", jdbcType=JdbcType.BIGINT),
        @Result(column="mem_discount_name", property="memDiscountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mem_id", property="memId", jdbcType=JdbcType.BIGINT),
        @Result(column="mem_name", property="memName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mem_phone", property="memPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="mem_card_id", property="memCardId", jdbcType=JdbcType.BIGINT),
        @Result(column="mem_card_type", property="memCardType", jdbcType=JdbcType.INTEGER),
        @Result(column="mem_card_no", property="memCardNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_model", property="payModel", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_type", property="payType", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_gold", property="payGold", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_price", property="payPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_real_price", property="payRealPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_serial_no", property="paySerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="deduction_price", property="deductionPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="order_status", property="orderStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="total_price", property="totalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="pay_time", property="payTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="cancel_time", property="cancelTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="cancel_remarks", property="cancelRemarks", jdbcType=JdbcType.VARCHAR),
        @Result(column="finish_time", property="finishTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="remarks", property="remarks", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_time", property="refundTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="refund_price", property="refundPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="refund_content", property="refundContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="refusal_refund_content", property="refusalRefundContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="Identification_code", property="identificationCode", jdbcType=JdbcType.BIGINT),
        @Result(column="profit_sharing_status", property="profitSharingStatus", jdbcType=JdbcType.BIT),
        @Result(column="profit_sharing_ratio", property="profitSharingRatio", jdbcType=JdbcType.DECIMAL),
        @Result(column="account_merchant_num", property="accountMerchantNum", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighOrder> selectByExample(HighOrderExample example);

    @Select({
        "select",
        "id, order_no, mem_discount_id, mem_discount_name, mem_id, mem_name, mem_phone, ",
        "mem_card_id, mem_card_type, mem_card_no, pay_model, pay_type, pay_gold, pay_price, ",
        "pay_real_price, pay_serial_no, deduction_price, order_status, total_price, create_time, ",
        "pay_time, cancel_time, cancel_remarks, finish_time, remarks, refund_time, refund_price, ",
        "refund_content, refusal_refund_content, Identification_code, profit_sharing_status, ",
        "profit_sharing_ratio, account_merchant_num, ext_1, ext_2, ext_3",
        "from high_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mem_discount_id", property="memDiscountId", jdbcType=JdbcType.BIGINT),
        @Result(column="mem_discount_name", property="memDiscountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mem_id", property="memId", jdbcType=JdbcType.BIGINT),
        @Result(column="mem_name", property="memName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mem_phone", property="memPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="mem_card_id", property="memCardId", jdbcType=JdbcType.BIGINT),
        @Result(column="mem_card_type", property="memCardType", jdbcType=JdbcType.INTEGER),
        @Result(column="mem_card_no", property="memCardNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_model", property="payModel", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_type", property="payType", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_gold", property="payGold", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_price", property="payPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_real_price", property="payRealPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_serial_no", property="paySerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="deduction_price", property="deductionPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="order_status", property="orderStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="total_price", property="totalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="pay_time", property="payTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="cancel_time", property="cancelTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="cancel_remarks", property="cancelRemarks", jdbcType=JdbcType.VARCHAR),
        @Result(column="finish_time", property="finishTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="remarks", property="remarks", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_time", property="refundTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="refund_price", property="refundPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="refund_content", property="refundContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="refusal_refund_content", property="refusalRefundContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="Identification_code", property="identificationCode", jdbcType=JdbcType.BIGINT),
        @Result(column="profit_sharing_status", property="profitSharingStatus", jdbcType=JdbcType.BIT),
        @Result(column="profit_sharing_ratio", property="profitSharingRatio", jdbcType=JdbcType.DECIMAL),
        @Result(column="account_merchant_num", property="accountMerchantNum", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighOrder selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighOrderSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighOrder record, @Param("example") HighOrderExample example);

    @UpdateProvider(type=HighOrderSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighOrder record, @Param("example") HighOrderExample example);

    @UpdateProvider(type=HighOrderSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighOrder record);

    @Update({
        "update high_order",
        "set order_no = #{orderNo,jdbcType=VARCHAR},",
          "mem_discount_id = #{memDiscountId,jdbcType=BIGINT},",
          "mem_discount_name = #{memDiscountName,jdbcType=VARCHAR},",
          "mem_id = #{memId,jdbcType=BIGINT},",
          "mem_name = #{memName,jdbcType=VARCHAR},",
          "mem_phone = #{memPhone,jdbcType=VARCHAR},",
          "mem_card_id = #{memCardId,jdbcType=BIGINT},",
          "mem_card_type = #{memCardType,jdbcType=INTEGER},",
          "mem_card_no = #{memCardNo,jdbcType=VARCHAR},",
          "pay_model = #{payModel,jdbcType=INTEGER},",
          "pay_type = #{payType,jdbcType=INTEGER},",
          "pay_gold = #{payGold,jdbcType=INTEGER},",
          "pay_price = #{payPrice,jdbcType=DECIMAL},",
          "pay_real_price = #{payRealPrice,jdbcType=DECIMAL},",
          "pay_serial_no = #{paySerialNo,jdbcType=VARCHAR},",
          "deduction_price = #{deductionPrice,jdbcType=DECIMAL},",
          "order_status = #{orderStatus,jdbcType=INTEGER},",
          "total_price = #{totalPrice,jdbcType=DECIMAL},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "pay_time = #{payTime,jdbcType=TIMESTAMP},",
          "cancel_time = #{cancelTime,jdbcType=TIMESTAMP},",
          "cancel_remarks = #{cancelRemarks,jdbcType=VARCHAR},",
          "finish_time = #{finishTime,jdbcType=TIMESTAMP},",
          "remarks = #{remarks,jdbcType=VARCHAR},",
          "refund_time = #{refundTime,jdbcType=TIMESTAMP},",
          "refund_price = #{refundPrice,jdbcType=DECIMAL},",
          "refund_content = #{refundContent,jdbcType=VARCHAR},",
          "refusal_refund_content = #{refusalRefundContent,jdbcType=VARCHAR},",
          "Identification_code = #{identificationCode,jdbcType=BIGINT},",
          "profit_sharing_status = #{profitSharingStatus,jdbcType=BIT},",
          "profit_sharing_ratio = #{profitSharingRatio,jdbcType=DECIMAL},",
          "account_merchant_num = #{accountMerchantNum,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighOrder record);
}